#!/usr/local/bin/perl -w

###################################################
# Script : pop3.pl                                #
# Version : 0.3.6                                 #
# Author : DoppelX                                #
# License : GPL                                   #
# Last Modified : Fri, 01 Mar 2002 01:15:22 +0900 #
###################################################

use Socket;					# Socket⥸塼Ȥ

$username = '';
$password = '';
$hostname = '';
$port = 0;
$interactive_mode = 0;		# ⡼Ƚ(ư/)(ǥեȤϼư)
$delete_flag = 0;			# åȽե饰
$logfile = '-';				# ǥեȤ '-' ('>-' ɸ)
$verbose_flag = 0;			# ǥХå⡼Ƚե饰
$list_flag = 0;				# LISTޥȽե饰
$retr_flag = 0;				# RETRޥȽե饰
$display_lines = 15;		# ٤ɽåιԿ(ǥեȤ15)
$lines = 0;					# ɽåιԿ()
$status = '';				# 쥹ݥ󥹥ơǼ
$responses = 'No such message.';		# 쥹ݥ󥹥åǼ

#--------------------  ------------------------

		# ʤä饨顼
&usage if(!@ARGV);

for($i = 0; $i < @ARGV; $i++){
	$_ = $ARGV[$i];

	if(m/^-d$/i){
		$delete_flag = 1 || &usage;
	}
	elsif(m/^-v$/i){
		$verbose_flag = 1 || &usage;
	}
	elsif(m/^-i$/i){
		$interactive_mode = 1 || &usage;
	}
	elsif(m/^-f$/i){
		$logfile = $ARGV[++$i] || &usage;
		&usage if($logfile =~ m/^-d$/i || $logfile =~ m/^-v$/i || $logfile =~ m/^-l$/i || $logfile =~ m/^-i$/i);
	}
	elsif(m/^-l$/i && $ARGV[++$i] =~ m/^\d+$/){
		$display_lines = $ARGV[$i] || &usage;
	}
	elsif(m/^[\w\.-]+$/){
		$hostname = $_ || &usage;
		if($_ = $ARGV[++$i]){
			if(m/^\d+$/){
				$port = $_;
			}
			else{
				&usage;
			}
		}
		if($ARGV[++$i]){
			&usage;
		}
	}
	else{
		&usage;
	}
}

		# ۥ̤̾ʤ饨顼
&usage unless($hostname);

#----------- ͥ -------------

print STDERR "\nConnecting to $hostname...";
unless($port){
	$port = getservbyname('pop3', 'tcp') || 110;
}
&est_connect(SERVER, $hostname, $port);
print STDERR "Connected.\n";
&read_response;

print STDERR "User: ";
$username = <STDIN>;
chomp $username;
&send_command("USER $username\r\n");
&read_response;

print STDERR "Password: ";
$password = <STDIN>;
chomp $password;
&send_command("PASS $password\r\n");
$ret = &read_response;
		# ǧڥ顼ξϽλ
if($ret =~ m/^-ERR/i){
	print STDERR "Login failed.\n";
	exit;
}

		# LISTȯ
$list_flag = 1;
&send_command("LIST\r\n");
&read_response;
$list_flag = 0;

open(OUT, ">$logfile") || die "$logfile: $!";
$retr_flag = 1;
		# å
if(@mails){
	unless($interactive_mode){
		&normal_mode;
	}
	while($interactive_mode){
		&interactive_mode;
	}
}
else{
	print "There is no message.\n";
}
close(OUT);
$retr_flag = 0;

		# QUITäƥåλ
&send_command("QUIT\r\n");
&read_response;
close(SERVER);
print STDERR "Disconnected from $hostname.\n";

exit;

#-------- Ρޥ⡼(ư᡼) --------

sub normal_mode{
			# ƥ᡼ˤĤ
	foreach(@mails){
		$num = $_;
		$lines = 0;
		print STDERR "Starts downloading message $num.\n";
		&send_command("RETR $num\r\n");		# RETRȯ
		&read_response;
		if($status =~ m/^\+OK$/i){
			print STDERR "Downloading message $num succeeded.\n";

					# "-d"ץ󤬻ꤵƤ(쥹ݥ󥹥ơ"-ERR"ʤõȤϤʤ)
			if($delete_flag){
				$retr_flag = 0;
				print STDERR "Deletes message $num.\n";
				&send_command("DELE $num\r\n");		# DELEȯ
				$ret = &read_response;
				if(!($verbose_flag) && $ret =~ m/^-ERR/i){
					s/^-ERR (.+)\r\n//i;
					print STDERR "$1\n";		# 쥹ݥ󥹥ơ"-ERR"ʤ饨顼åɽ
				}
				elsif($ret =~ m/^\+OK/i){
					print STDERR "Deleting message $num succeeded.\n";
				}
				$retr_flag = 1;
			}
		}
	}
}

#-------- å⡼(򼰥᡼) --------

sub interactive_mode{
			# å
	$valid = 0;
	while(!$valid){
		print STDERR "Choose message to download or \"q\" to quit. (";
		foreach(@mails){
			print STDERR "$_,";
		}
		print STDERR "q): ";
		$num = <STDIN>;
		chomp $num;
		if($num =~ m/^\d+$/){
			foreach(@mails){
				if($num == $_){
					$valid = 1;		# ¸ߤåֹʤ$valid򿿤
					last;
				}
			}
		}
				# q򤵤줿$interactive_mode򵶤ˤƽλ
		elsif($num =~ m/^q$/i){
			$interactive_mode = 0;
			return;
		}
	}
	$valid = 0;

	$lines = 0;
	print STDERR "Starts downloading message $num.\n";
	&send_command("RETR $num\r\n");		# RETRȯ
	&read_response;
	print STDERR "Downloading message $num succeeded.\n" if($status =~ m/^\+OK$/i);
	return if($status =~ m/^-ERR$/i);		# 쥹ݥ󥹥ơ"-ERR"ʤõȤϤʤ

	print STDERR "Deletes this message? (y/n): ";
	$delete_message = <STDIN>;
	chomp $delete_message;
	if($delete_message =~ m/^y$/i){
		$retr_flag = 0;
		print STDERR "Deletes message $num.\n";
		&send_command("DELE $num\r\n");		# DELEȯ
		$ret = &read_response;
		if(!($verbose_flag) && $ret =~ m/^-ERR/i){
			s/^-ERR (.+)\r\n//i;
			print STDERR "$1\n";		# 쥹ݥ󥹥ơ"-ERR"ʤ饨顼åɽ
		}
		elsif($ret =~ m/^\+OK/i){
			print STDERR "Deleting message $num succeeded.\n";
					# LISTȯ
			$list_flag = 1;
			@mails = ();
			&send_command("LIST\r\n");
			&read_response;
			$list_flag = 0;
		}
		$retr_flag = 1;
	}
	else{
		return;
	}
}

#---------------- Ф˥ǡ ----------------

sub send_command{
	$verbose_flag && print "---> $_[0]";
	print SERVER $_[0];
}


#------ ФΥ쥹ݥ󥹤ɤ߹ߡɽ --------

sub read_response{
	unless($list_flag || $retr_flag){
		$buf = <SERVER>;
		$verbose_flag && print "$buf";
		return $buf;
	}
	else{
		$buf = '';		# 쥹ݥѥХåե򥯥ꥢ
		while(<SERVER>){
			last if(m/^\.\r\n$/);		# ".<CR><LF>"ΤߤιԤ褿롼פȴ

					# LISTΥ쥹ݥ
			if($list_flag){
						# "᡼ֹ ᡼륵"ȤԤʤ
				if(m/^(\d+) (\d+)\r\n$/){
					$num = $1;
					#$size = $2;
					push(@mails, $num);		# ᡼ֹ@mailspush
				}
				$buf .= $_;
			}
					# RETRΥ쥹ݥ
			elsif($retr_flag){
				s/^\.\././;		# Ƭ"..""."᤹
						# 1(쥹ݥ󥹹)ʤ
				if($lines == 0){
					if(m/^([\+-]...?) (.+)\r\n$/i){
						$status = $1;
						$responses = $2;
					}

					if($verbose_flag){
						print "$status $responses\r\n";		# "-v"ץͭʤ쥹ݥ󥹤ɽ
					}
							# 顼ʤ餳Υåɽ
					if($status =~ m/^-ERR$/i){
						$verbose_flag || print STDERR "$responses\n";
						return;
					}

					s/^([\+-]...?) (.+)\r\n$//i;		# 쥹ݥ󥹹Խ
				}
				
				print OUT $_;		# ༡ɽ
						# ɽԿ$display_linesˤʤäö
				if($logfile eq '-' && !(++$lines % $display_lines)){
					print STDERR "\nHit \"Enter\" key to continue.";
					<STDIN>;
				}
			}
		}

		print "$buf" if($list_flag && $verbose_flag);
	}
}

#--------- Ϥ줿ۥȤΥݡȤ³ ---------

sub est_connect{
	($SOCK, $host, $port) = @_;

				# ۥ̾IP ɥ쥹ι¤ΤѴ
	$iaddr = inet_aton($host) || die "Unknown host $host.\n";

				# ݡֹ IP ɥ쥹ޤȤƹ¤ΤѴ
	$sock_addr = pack_sockaddr_in($port, $iaddr);

				# å
	socket($SOCK, PF_INET, SOCK_STREAM, 0) || die "Making socket failed.\n";

				# ΥۥȤλ port ³
	connect($SOCK, $sock_addr) || die "Connecting port $port of $hostname failed.\n";

				# եϥɥХåե󥰤ʤ
	select($SOCK); $|=1; select(STDOUT);
}

#------------------- ˡɽ ---------------------

sub usage{
	print STDERR <<USAGE;

POP3 Client CL 0.3.6
Copyright (C) 2002 DoppelX
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under certain conditions. See the file GPL.txt for details.

Connects to a POP3 server and downloads messages.

./pop3.pl [-f file_name] [-d] [-v] [-l lines] [-i] host_name [port]

  -f file_name       Specifies a file to write down the messages.
  -d                 Deletes messages automatically after downloads
                     them. 
  -v                 Enables debugging.
  -l lines           Specifies the number of lines to display the
                     downloaded messages.(Default: 15 lines)
  -i                 Turns on interactive prompting.
  host_name          Specifies the host name of IP address of the
                     remote host to connect to.
  port               Specifies the port number of the remote host.
USAGE
	exit;
}
